config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.nix.new
config etc/nix/nix.conf.new
( cd usr/bin ; rm -rf nix-build )
( cd usr/bin ; ln -sf nix nix-build )
( cd usr/bin ; rm -rf nix-channel )
( cd usr/bin ; ln -sf nix nix-channel )
( cd usr/bin ; rm -rf nix-collect-garbage )
( cd usr/bin ; ln -sf nix nix-collect-garbage )
( cd usr/bin ; rm -rf nix-copy-closure )
( cd usr/bin ; ln -sf nix nix-copy-closure )
( cd usr/bin ; rm -rf nix-daemon )
( cd usr/bin ; ln -sf nix nix-daemon )
( cd usr/bin ; rm -rf nix-env )
( cd usr/bin ; ln -sf nix nix-env )
( cd usr/bin ; rm -rf nix-hash )
( cd usr/bin ; ln -sf nix nix-hash )
( cd usr/bin ; rm -rf nix-instantiate )
( cd usr/bin ; ln -sf nix nix-instantiate )
( cd usr/bin ; rm -rf nix-prefetch-url )
( cd usr/bin ; ln -sf nix nix-prefetch-url )
( cd usr/bin ; rm -rf nix-shell )
( cd usr/bin ; ln -sf nix nix-shell )
( cd usr/bin ; rm -rf nix-store )
( cd usr/bin ; ln -sf nix nix-store )
( cd usr/libexec/nix ; rm -rf build-remote )
( cd usr/libexec/nix ; ln -sf /usr/bin/nix build-remote )
